package com.persagy.server.jms

import com.persagy.mybatis.SMybatisDao
import com.persagy.server.Opt
import com.persagy.server.jms.bean.MessageNotice
import com.persagy.server.jms.bean.SBaseNotice
import com.persagy.server.jms.bean.SynchronousMessageObj
import com.persagy.server.jms.bean.SynchronousMessageRel
import com.persagy.service.SObjectService
import com.persagy.service.utils.SJsonUtil
import org.slf4j.LoggerFactory
import org.springframework.amqp.rabbit.annotation.RabbitHandler
import org.springframework.amqp.rabbit.annotation.RabbitListener
import org.springframework.stereotype.Component
import org.springframework.stereotype.Service
import java.util.*

/**
 * 消息
 *
 * @author wx  <zhangweixin@sagacloud.com>
 * @date  2020/10/28 8:43
 */
@Component
@Service
class RabbitMqService: RabbitMqBaseService() {
    companion object {
        /** 日志 */
        private val logger = LoggerFactory.getLogger(com.persagy.server.services.base.Service::class.java)
    }

    /** 缓存对象数据服务 */
    var synchronousMessageObjService = SObjectService(SMybatisDao(SynchronousMessageObj::class.java))
    /** 缓存关系数据服务 */
    var snchronousMessageRelService = SObjectService(SMybatisDao(SynchronousMessageRel::class.java))

    /**
     * 接收消息
     *
     * @param
     */
    @RabbitListener(queues = ["queue-adm"])
    @RabbitHandler
    fun receiveMessage(message: String) {
        println("我是监听queue-adm的,仅满足queue-adm的过来 ， $message")
        val messageNotice = SJsonUtil.fromJson(message, MessageNotice::class.java)
        if (messageNotice != null) {
            when(messageNotice.objOrRel) {
                "objects" -> {
                    try {
                        /** id 列表不可以为空 */
                        if (!messageNotice.idList.isNullOrEmpty()) {
                            /** 遍历 id 列表 */
                            for (id in messageNotice.idList!!) {
                                /** 同步消息对象 */
                                val messageObj = SynchronousMessageObj()
                                messageObj.projectId = messageNotice.projectId
                                messageObj.objId = id
                                messageObj.id =  UUID.randomUUID().toString().replace("-", "")
                                messageObj.sign = 1
                                messageObj.objectType = objType(id)
                                messageObj.type = messageNotice.type
                                /** 插入数据 */
                                synchronousMessageObjService.insert(messageObj)
                            }
                        }
                    } catch (e: Exception) {
                        e.printStackTrace()
                    }
                }
                "rel" -> {
                    /** 关系消息对象 */
                    val messageRel = SynchronousMessageRel()
                    messageRel.projectId = messageNotice.projectId
                    messageRel.id = UUID.randomUUID().toString().replace("-", "")
                    messageRel.sign = 1
                    messageRel.ops = messageNotice.ops
                    messageRel.type = messageNotice.type
                    messageRel.fromId = messageNotice.fromId
                    messageRel.toId = messageNotice.toId
                    snchronousMessageRelService.insert(messageRel)
                }
            }
        }
    }


    /**
     * 合并重新
     *
     * @param lastNotice 最后一条消息对象
     * @param notice     当前消息对象
     * @return 是否合并
     */
    override fun mergeNotice(lastNotice: SBaseNotice, notice: SBaseNotice): Boolean {
        // 对象消息合并
        if (notice is MessageNotice) {
            // 如果最后发送对象不是对象消息，则返回false
            val last = lastNotice as? MessageNotice ?: return false
            // 操作不同，对象不同，项目不同的通知不合并
            if (notice.ops != notice.ops || notice.type != last.type || notice.projectId != last.projectId) {
                return false
            }
            // 合并消息
            notice.idList?.let { last.idList?.addAll(it) }
            return true
        }
//        else if (notice is RelationNotice) {  // 关系消息合并
//            // TODO: 补 关系类型通知合并代码
//            return true
//        }
        return false
    }

    /**
     * 发送消息(对象消息)
     *
     * @param projectId     项目 id
     * @param type          操作符类型
     * @param objId         对象 id
     */
    fun sendObjects(projectId: String, type: String, objId: String){
       logger.debug("发送消息= ***********************************************************************************")
        /** 生成 id */
        val id = UUID.randomUUID().toString().replace("-", "")
        /** 消息对象 */
        val messageNotice = MessageNotice(projectId, "objects", type, null, id,
            hashSetOf(objId), null, null)
        /** 发送消息 */
        sendMessage(Opt.exchange,Opt.routingKey,messageNotice)
    }

    /**
     * 发送消息(关系)
     *
     * @param projectId     项目 id
     * @param type          关系类型
     * @param fromId        主 id
     * @param toId          从 id
     */
    fun sendRel(projectId: String,type: String,fromId: String,toId: String){
        /** 生成 id */
        val id = UUID.randomUUID().toString().replace("-", "")
        /** 消息对象 */
        val messageNotice = MessageNotice(projectId, "rel", type, null, id,
            null, fromId, toId)
        /** 发送消息 */
        sendMessage(Opt.exchange,Opt.routingKey,messageNotice)
    }

    /**
     * 根据对象 id 转换对象类型
     *
     * @param id    对象 id
     * @return 对象类型
     */
    private fun objType(id: String): String {
        when {
            id.startsWith("Eq") -> {
                return "equipment"
            }
            id.startsWith("Fl") -> {
                return "floor"
            }
            id.startsWith("Bd") -> {
                return "building"
            }
            id.startsWith("Sp") -> {
                return "space"
            }
            id.startsWith("Sy") -> {
                return "system"
            }
            id.startsWith("Sh") -> {
                return "shaft"
            }
            id.startsWith("Ec") -> {
                return "component"
            }
            else -> return "object"
        }
    }
}